<html><head><title>WebSocket</title>
<link rel="stylesheet" type="text/css" href="stylesheet.css">
<script type="text/javascript" src="/socketcluster.js"></script>
<script>
/** browser dependent definition are aligned to one and the same standard name **/
navigator.getUserMedia = navigator.getUserMedia || navigator.mozGetUserMedia || navigator.webkitGetUserMedia;
window.RTCPeerConnection = window.RTCPeerConnection || window.mozRTCPeerConnection || window.webkitRTCPeerConnection;
window.RTCIceCandidate = window.RTCIceCandidate || window.mozRTCIceCandidate || window.webkitRTCIceCandidate;
window.RTCSessionDescription = window.RTCSessionDescription || window.mozRTCSessionDescription || window.webkitRTCSessionDescription;
window.SpeechRecognition = window.SpeechRecognition || window.webkitSpeechRecognition || window.mozSpeechRecognition
  || window.msSpeechRecognition || window.oSpeechRecognition;

var localVideoElem = null,
  remoteVideoElem = null,
  localVideoStream = null,
  videoCallButton = null,
  endCallButton = null;
var peerConn = null,
  peerConnCfg = {'iceServers':
    [{'url': 'stun:stun.services.mozilla.com'},
     {'url': 'stun:stun.l.google.com:19302'}]
  };

function prepareCall() {
  peerConn = new RTCPeerConnection(peerConnCfg);
  // send any ice candidates to the other peer
  peerConn.onicecandidate = onIceCandidateHandler;
  // once remote stream arrives, show it in the remote video element
  peerConn.onaddstream = onAddStreamHandler;
};

// run start(true) to initiate a call
function initiateCall() {
  prepareCall();
  // get the local stream, show it in the local video element and send it
  navigator.getUserMedia({ "audio": true, "video": true }, function (stream) {
    localVideoStream = stream;
    localVideo.src = URL.createObjectURL(localVideoStream);
    peerConn.addStream(localVideoStream);
    createAndSendOffer();
  }, function(error) { console.log(error);});
};

function answerCall() {
  prepareCall();
  // get the local stream, show it in the local video element and send it
  navigator.getUserMedia({ "audio": true, "video": true }, function (stream) {
    localVideoStream = stream;
    localVideo.src = URL.createObjectURL(localVideoStream);
    peerConn.addStream(localVideoStream);
    createAndSendAnswer();
  }, function(error) { console.log(error);});
};

function createAndSendOffer() {
  peerConn.createOffer(
    function (offer) {
      var off = new RTCSessionDescription(offer);
      peerConn.setLocalDescription(new RTCSessionDescription(off),
        function() {
          socket.publish(datasend, {'type': 'agentsdp', "sdp": off });
          console.log(JSON.stringify({"type": "agentsdp", "sdp": off }));
        },
        function(error) { console.log(error);}
      );
    },
    function (error) { console.log(error);}
  );
};

function createAndSendAnswer() {
  peerConn.createAnswer(
    function (answer) {
      var ans = new RTCSessionDescription(answer);
      peerConn.setLocalDescription(ans, function() {
          socket.publish(datasend, {'type': 'agentsdp', "sdp": ans });
        },
        function (error) { console.log(error);}
      );
    },
    function (error) {console.log(error);}
  );
};

function onIceCandidateHandler(evt) {
  if (!evt || !evt.candidate) return;
  socket.publish(datasend, {"type": "agentcandidate", "candidate": evt.candidate });
};

function onAddStreamHandler(evt) {
  // set remote video stream as source for remote video HTML5 element
  remoteVideo.src = URL.createObjectURL(evt.stream);
};

function endCall() {
  peerConn.close();
  peerConn = null;
  if (localVideoStream) {
    localVideoStream.getTracks().forEach(function (track) {
      track.stop();
    });
    localVideo.src = "";
  }
  if (remoteVideo) remoteVideo.src = "";

	localVideoElem = null
	  remoteVideoElem = null
	  localVideoStream = null
	  videoCallButton = null
	  endCallButton = null
	peerConn = null

};

function makeid(num)
{
    var text = "";
    var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";

    for( var i=0; i < num; i++ )
        text += possible.charAt(Math.floor(Math.random() * possible.length));

    return text;
}

// set a global variable
var chatname = 'An Agent';

// Initiate the connection to the server
var socket = socketCluster.connect();

socket.on('error', function (err) {
	throw 'Socket error - ' + err;
});

// On a successful connection
socket.on('connect', function () {
	console.log('Server Channel Connected');
	$("status").innerHTML = '<font color="green">Online</font>';
});

// we want to start a data channel that we listen on
datalisten = makeid(10);
var dataChannel = socket.subscribe(datalisten);
console.log('Listening on data channel');

// we need a varialbe to determin if webrtc is active
var webrtc_active = false;

// Events and messages direct from remote party
dataChannel.watch(function (data) {
	switch(data.type)
	{
		case 'newcall':
			switch(data.code)
			{
				case 'videochat':
					console.log('You have a videochat request, click videochat');
					datasend = data.datachannel;
					ListenClientChannel(datasend);
					document.getElementById('videoanswer').hidden = false;
					document.getElementById('voiceanswer').hidden = true;
					document.getElementById('textanswer').hidden = true;
					$("status").innerHTML = '<font color="magenta">Video Chat - Please answer</font>';
				break;

				case 'voicechat':
					console.log('You have a voicechat request, click voicechat');
					datasend = data.datachannel;
					ListenClientChannel(datasend);
					document.getElementById('videoanswer').hidden = true;
					document.getElementById('voiceanswer').hidden = false;
					document.getElementById('textanswer').hidden = true;
					$("status").innerHTML = '<font color="magenta">Voice Chat - Please answer</font>';
				break;

				case 'textchat':
					console.log('You have a textchat request, click textchat');
					datasend = data.datachannel;
					ListenClientChannel(datasend);
					document.getElementById('videoanswer').hidden = true;
					document.getElementById('voiceanswer').hidden = true;
					document.getElementById('textanswer').hidden = false;
					$("status").innerHTML = '<font color="magenta">Text Chat - Please answer</font>';
				break;

				default:
					console.log('You have a connection request that is not understood '+JSON.stringify(data));
				break;
			}
		break;

		default:
			console.log("unknown message on data channel "+JSON.stringify(data));
		break;
	}
});


// regular server socket listener
socket.on('agentv1', function (data) {
	switch (data.type)
	{
		case 'failed':
		console.log('Error: ' + JSON.stringify(data));
		break;

		case 'success':
		console.log('Success: ' + JSON.stringify(data));
		break;

		case 'loginok':
		console.log('Success: ' + JSON.stringify(data));
			console.log('Successfully logged in '+data.name);
			document.getElementById('loginbox').hidden = true;
			document.getElementById('available').hidden = false;
			document.getElementById('unavailable').hidden = true;
			document.getElementById('logout').hidden = false;
			chatname = data.chatname;
		break;

	 	 default:
			console.log("unknown message on server channel "+JSON.stringify(data));
		break;
	}
});

function sendmsg() {
	var msg = {
		type: 'agenttext',
		data: document.getElementById('sendstr').value,
	};
	log("<font color=\"red\">"+document.getElementById('sendstr').value+"</font>")
	socket.publish(datasend,msg);
}

function available() {
	var msg = {
		type: 'available',
	};
  socket.emit('agentv1', msg);
	document.getElementById('available').hidden = true;
	$("status").innerHTML = '<font color="orange">Available Waiting for call</font>';
	document.getElementById('available').hidden = true;
	document.getElementById('unavailable').hidden = false;
}

function unavailable() {
        var msg = {
                type: 'unavailable',
        };
  socket.emit('agentv1', msg);
        document.getElementById('available').hidden = true;
        $("status").innerHTML = '<font color="green">Online</font>';
	document.getElementById('available').hidden = false;
	document.getElementById('unavailable').hidden = true;
	document.getElementById('voiceanswer').hidden = true;
	document.getElementById('videoanswer').hidden = true;
	document.getElementById('textanswer').hidden = true;
}

function logout() {
	var msg = {
		type: 'logout',
	};
	socket.emit('agentv1', msg);
	$("status").innerHTML = '<font color="green">Online</font>';
	document.getElementById('chatbox').hidden = true;
	document.getElementById('voiceanswer').hidden = true;
	document.getElementById('videoanswer').hidden = true;
	document.getElementById('textanswer').hidden = true;
	document.getElementById('end').hidden = true;
	document.getElementById('logout').hidden = true;
	document.getElementById('available').hidden = true;
	document.getElementById('unavailable').hidden = true;
	document.getElementById('loginbox').hidden = false;
}

function login() {
	var msg = {
		type: 'login',
		username: document.getElementById('username').value,
		password: document.getElementById('password').value,
		channel: datalisten,
  };
  socket.emit('agentv1',msg);
}


function videoanswer() {
	var msg = {
		type: 'answervideochat',
  };
  socket.publish(datasend,msg);
	webrtc_active = true;

	prepareCall();
	// get the local stream, show it in the local video element and send it
	navigator.getUserMedia({ 'audio': true, 'video': true }, function (stream) {
		localVideoStream = stream;
		localVideo.src = URL.createObjectURL(localVideoStream);
		peerConn.addStream(localVideoStream);
		createAndSendOffer();
	}, function(error) { console.log(error);});
		document.getElementById('end').hidden = false;
		document.getElementById('videoanswer').hidden = true;
		document.getElementById('unavailable').hidden = true;
		document.getElementById('logout').hidden = true;
		$("status").innerHTML = '<font color="orange">Video Chat - Connecting to client</font>';

		// send a message to the server to say we answered it
		var msg = {
				type: "answer",
				answertype: "videochat",
		  };
		  socket.emit('agentv1',msg);
}

function voiceanswer() {
	var msg = {
		type: 'answervoicechat',
  };
  socket.publish(datasend,msg);
	webrtc_active = true;

	prepareCall();
	// get the local stream, show it in the local video element and send it
	navigator.getUserMedia({ 'audio': true, 'video': false }, function (stream) {
		localVideoStream = stream;
		localVideo.src = URL.createObjectURL(localVideoStream);
		peerConn.addStream(localVideoStream);
		createAndSendOffer();
	}, function(error) { console.log(error);});
	document.getElementById('end').hidden = false;
	document.getElementById('voiceanswer').hidden = true;
	document.getElementById('unavailable').hidden = true;
	document.getElementById('logout').hidden = true;
	$("status").innerHTML = '<font color="orange">Voice Chat - Connecting to client</font>';
	// send a message to the server to say we answered it
	var msg = {
			type: "answer",
			answertype: "voicechat",
	  };
	  socket.emit('agentv1',msg);
}

function textanswer() {
	var msg = {
		type: 'answertextchat',
		agent: chatname,
  };
  socket.publish(datasend,msg);
	document.getElementById('end').hidden = false;
	document.getElementById('textanswer').hidden = true;
	document.getElementById('videoanswer').hidden = false;
	document.getElementById('voiceanswer').hidden = false;
	document.getElementById('unavailable').hidden = true;
	document.getElementById('logout').hidden = true;
	$("status").innerHTML = '<font color="orange">Text Chat - Connecting to client</font>';

	// send a message to the server to say we answered it
	var msg = {
			type: "answer",
			answertype: "textchat",
	  };
	  socket.emit('agentv1',msg);
}

function cancelchat() {
	var msg = {
		type: "cancel",
  };
  socket.emit('agentv1',msg);

	if (webrtc_active) endCall();

	var msg = {
		type: "endcall",
	};
	socket.publish(datasend,msg);
	$("status").innerHTML = '<font color="green">Online - Caller ended call</font>';
	document.getElementById('chatbox').hidden = true;
	document.getElementById('voiceanswer').hidden = true;
	document.getElementById('videoanswer').hidden = true;
	document.getElementById('textanswer').hidden = true;
	document.getElementById('end').hidden = true;
	document.getElementById('logout').hidden = false;
	document.getElementById('unavailable').hidden = false;
	$("log").innerHTML = '';
	$("sendstr").innerHTML = '';
}

// The client passed us the channel he is using
// we will subscribe to this channel
// And create a list of actions for each message type
function ListenClientChannel(channel){
	var clientChannel = socket.subscribe(channel);
	console.log('Listening on client channel');
	// Events and messages direct from remote party
	clientChannel.watch(function (data) {
		switch(data.type)
		{
			case 'clienttext':
				log("<font color=\"blue\">"+data.data+"</font>")
			break;

			case 'clientping':
			  console.log("received ping - client alive");
				$("status").innerHTML = '<font color="red">You are connected</font>';
				document.getElementById('chatbox').hidden = false;
			break;

			case 'clientsdp':
			if (!peerConn) answerCall();
			console.log("Received SDP from remote peer.");
			peerConn.setRemoteDescription(new RTCSessionDescription(data.sdp));
			break;

			case 'clientcandidate':
			console.log("Received ICECandidate from remote peer.");
			peerConn.addIceCandidate(new RTCIceCandidate(data.candidate));
			break;

			case 'agentcandidate':
			break;

			case 'agentsdp':
			break;

			case 'agenttext':
			break;

			case 'agentping':
			break;

			case 'clientendcall':
			console.log("Received message to terminate webrtc call");
			var msg = {
				type: "cancel",
			};
			if (webrtc_active) endCall();
			socket.emit('agentv1',msg);
				$("status").innerHTML = '<font color="green">Online - Caller ended call</font>';
				document.getElementById('chatbox').hidden = true;
				document.getElementById('voiceanswer').hidden = true;
				document.getElementById('videoanswer').hidden = true;
				document.getElementById('textanswer').hidden = true;
				document.getElementById('end').hidden = true;
				document.getElementById('logout').hidden = false;
				document.getElementById('unavailable').hidden = false;
				$("log").innerHTML = '';
				$("sendstr").innerHTML = '';
			break;
			default:
				console.log("unknown message on client channel "+JSON.stringify(data));
			break;
		}
	});
}

// Utilities
function $(id){ return document.getElementById(id); }
function log(msg){ $("log").innerHTML+="<br>"+msg; }
//function onkey(event){ if(event.keyCode==13){ send(); } }
</script>

</head>
<body>
<div id="status"><font color="red">Connecting ...</font></div>
<div id="loginbox">
	username: <input id="username" type="username" value="dan"/></p>
	password: <input id="password" type="password" value="dan"/></p>
	<button id="login" onclick="login()">Login</button>
</div>
<button id='available' onclick="available()" hidden>Available</button>
<button id='unavailable' onclick="unavailable()" hidden>Unavailable</button>
<button id='logout' onclick="logout()" hidden>Logout</button>
<button id='videoanswer' onclick="videoanswer()" hidden>Video Answer</button>
<button id='voiceanswer' onclick="voiceanswer()" hidden>Voice Answer</button>
<button id='textanswer' onclick="textanswer()" hidden>Text Answer</button>

<div id="chatbox" hidden>
		<button id='end' onclick="cancelchat()" hidden>End Call</button></p>
	</br>Send message: <br/>
	<input id="sendstr" type="textbox"/>
	<button onclick="sendmsg()">Send</button>
</br></p><div id="log"></div>
</div>
<video id="localVideo"  autoplay muted="true"></video>
<video id="remoteVideo" width="1240" height="1024" autoplay align="right"></video>
</body>
</html>
